install.sh 8.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. KERN=$(uname -r)
  29. case "$KERN" in
  30. *icrosoft*WSL2 | *icrosoft*wsl2) ;;
  31. *icrosoft) error "Microsoft WSL1 is not currently supported. Please upgrade to WSL2 with 'wsl --set-version <distro> 2'" ;;
  32. *) ;;
  33. esac
  34. SUDO=
  35. if [ "$(id -u)" -ne 0 ]; then
  36. # Running as root, no need for sudo
  37. if ! available sudo; then
  38. error "This script requires superuser permissions. Please re-run as root."
  39. fi
  40. SUDO="sudo"
  41. fi
  42. NEEDS=$(require curl awk grep sed tee xargs)
  43. if [ -n "$NEEDS" ]; then
  44. status "ERROR: The following tools are required but missing:"
  45. for NEED in $NEEDS; do
  46. echo " - $NEED"
  47. done
  48. exit 1
  49. fi
  50. status "Downloading ollama..."
  51. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.ai/download/ollama-linux-$ARCH"
  52. for BINDIR in /usr/local/bin /usr/bin /bin; do
  53. echo $PATH | grep -q $BINDIR && break || continue
  54. done
  55. status "Installing ollama to $BINDIR..."
  56. $SUDO install -o0 -g0 -m755 -d $BINDIR
  57. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  58. install_success() {
  59. status 'The Ollama API is now available at 0.0.0.0:11434.'
  60. status 'Install complete. Run "ollama" from the command line.'
  61. }
  62. trap install_success EXIT
  63. # Everything from this point onwards is optional.
  64. configure_systemd() {
  65. if ! id ollama >/dev/null 2>&1; then
  66. status "Creating ollama user..."
  67. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  68. fi
  69. status "Adding current user to ollama group..."
  70. $SUDO usermod -a -G ollama $(whoami)
  71. status "Creating ollama systemd service..."
  72. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  73. [Unit]
  74. Description=Ollama Service
  75. After=network-online.target
  76. [Service]
  77. ExecStart=$BINDIR/ollama serve
  78. User=ollama
  79. Group=ollama
  80. Restart=always
  81. RestartSec=3
  82. Environment="PATH=$PATH"
  83. [Install]
  84. WantedBy=default.target
  85. EOF
  86. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  87. case $SYSTEMCTL_RUNNING in
  88. running|degraded)
  89. status "Enabling and starting ollama service..."
  90. $SUDO systemctl daemon-reload
  91. $SUDO systemctl enable ollama
  92. start_service() { $SUDO systemctl restart ollama; }
  93. trap start_service EXIT
  94. ;;
  95. esac
  96. }
  97. if available systemctl; then
  98. configure_systemd
  99. fi
  100. if ! available lspci && ! available lshw; then
  101. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  102. exit 0
  103. fi
  104. check_gpu() {
  105. case $1 in
  106. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  107. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  108. nvidia-smi) available nvidia-smi || return 1 ;;
  109. esac
  110. }
  111. if check_gpu nvidia-smi; then
  112. status "NVIDIA GPU installed."
  113. exit 0
  114. fi
  115. if ! check_gpu lspci && ! check_gpu lshw; then
  116. install_success
  117. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  118. exit 0
  119. fi
  120. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  121. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  122. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  123. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  124. install_cuda_driver_yum() {
  125. status 'Installing NVIDIA repository...'
  126. case $PACKAGE_MANAGER in
  127. yum)
  128. $SUDO $PACKAGE_MANAGER -y install yum-utils
  129. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  130. ;;
  131. dnf)
  132. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  133. ;;
  134. esac
  135. case $1 in
  136. rhel)
  137. status 'Installing EPEL repository...'
  138. # EPEL is required for third-party dependencies such as dkms and libvdpau
  139. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  140. ;;
  141. esac
  142. status 'Installing CUDA driver...'
  143. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  144. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  145. fi
  146. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  147. }
  148. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  149. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  150. install_cuda_driver_apt() {
  151. status 'Installing NVIDIA repository...'
  152. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  153. case $1 in
  154. debian)
  155. status 'Enabling contrib sources...'
  156. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | $SUDO tee /etc/apt/sources.list.d/contrib.list > /dev/null
  157. if [ -f "/etc/apt/sources.list.d/debian.sources" ]; then
  158. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list.d/debian.sources | $SUDO tee /etc/apt/sources.list.d/contrib.sources > /dev/null
  159. fi
  160. ;;
  161. esac
  162. status 'Installing CUDA driver...'
  163. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  164. $SUDO apt-get update
  165. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  166. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  167. }
  168. if [ ! -f "/etc/os-release" ]; then
  169. error "Unknown distribution. Skipping CUDA installation."
  170. fi
  171. . /etc/os-release
  172. OS_NAME=$ID
  173. OS_VERSION=$VERSION_ID
  174. PACKAGE_MANAGER=
  175. for PACKAGE_MANAGER in dnf yum apt-get; do
  176. if available $PACKAGE_MANAGER; then
  177. break
  178. fi
  179. done
  180. if [ -z "$PACKAGE_MANAGER" ]; then
  181. error "Unknown package manager. Skipping CUDA installation."
  182. fi
  183. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  184. case $OS_NAME in
  185. centos|rhel) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -d '.' -f 1) ;;
  186. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  187. fedora) install_cuda_driver_yum $OS_NAME $OS_VERSION ;;
  188. amzn) install_cuda_driver_yum 'fedora' '35' ;;
  189. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  190. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  191. *) exit ;;
  192. esac
  193. fi
  194. if ! lsmod | grep -q nvidia; then
  195. KERNEL_RELEASE="$(uname -r)"
  196. case $OS_NAME in
  197. rocky) $SUDO $PACKAGE_MANAGER -y install kernel-devel kernel-headers ;;
  198. centos|rhel|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  199. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  200. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  201. *) exit ;;
  202. esac
  203. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  204. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  205. $SUDO dkms install $NVIDIA_CUDA_VERSION
  206. fi
  207. if lsmod | grep -q nouveau; then
  208. status 'Reboot to complete NVIDIA CUDA driver install.'
  209. exit 0
  210. fi
  211. $SUDO modprobe nvidia
  212. fi
  213. status "NVIDIA CUDA drivers installed."